import { visitParents as L, SKIP as C, CONTINUE as D } from "unist-util-visit-parents";
import { makeSingletonHighlighter as U, createHighlighter as V, bundledThemes as Y } from "shiki";
import { parseFragment as I } from "parse5";
import { fromParse5 as T } from "hast-util-from-parse5";
const j = (e) => {
  const r = /^(?<escaped>\s*):(?<token>[\w-]+):(?<content>[\w+\s\S]*)/gm.exec(e);
  if (!r) return e;
  const { groups: o } = r, { escaped: s, token: i, content: n } = o;
  if (s.length)
    s.length >= 1;
  else return { token: i, content: n };
  return e.substring(1);
}, z = (e) => {
  const { className: t } = e.properties;
  let r = "";
  for (const o of t)
    if (o.startsWith("language-")) {
      r = o.slice(9);
      break;
    }
  return r;
}, H = (
  // Note: overloads in JSDoc can’t yet use different `@template`s.
  /**
   * @type {(
   *   (<Condition extends string>(test: Condition) => (node: unknown, index?: number | null | undefined, parent?: Parent | null | undefined, context?: unknown) => node is Node & {type: Condition}) &
   *   (<Condition extends Props>(test: Condition) => (node: unknown, index?: number | null | undefined, parent?: Parent | null | undefined, context?: unknown) => node is Node & Condition) &
   *   (<Condition extends TestFunction>(test: Condition) => (node: unknown, index?: number | null | undefined, parent?: Parent | null | undefined, context?: unknown) => node is Node & Predicate<Condition, Node>) &
   *   ((test?: null | undefined) => (node?: unknown, index?: number | null | undefined, parent?: Parent | null | undefined, context?: unknown) => node is Node) &
   *   ((test?: Test) => Check)
   * )}
   */
  /**
   * @param {Test} [test]
   * @returns {Check}
   */
  function(e) {
    if (e == null)
      return Q;
    if (typeof e == "function")
      return b(e);
    if (typeof e == "object")
      return Array.isArray(e) ? G(e) : J(e);
    if (typeof e == "string")
      return M(e);
    throw new Error("Expected function, string, or object as test");
  }
);
function G(e) {
  const t = [];
  let r = -1;
  for (; ++r < e.length; )
    t[r] = H(e[r]);
  return b(o);
  function o(...s) {
    let i = -1;
    for (; ++i < t.length; )
      if (t[i].apply(this, s)) return !0;
    return !1;
  }
}
function J(e) {
  const t = (
    /** @type {Record<string, unknown>} */
    e
  );
  return b(r);
  function r(o) {
    const s = (
      /** @type {Record<string, unknown>} */
      /** @type {unknown} */
      o
    );
    let i;
    for (i in e)
      if (s[i] !== t[i]) return !1;
    return !0;
  }
}
function M(e) {
  return b(t);
  function t(r) {
    return r && r.type === e;
  }
}
function b(e) {
  return t;
  function t(r, o, s) {
    return !!(X(r) && e.call(
      this,
      r,
      typeof o == "number" ? o : void 0,
      s || void 0
    ));
  }
}
function Q() {
  return !0;
}
function X(e) {
  return e !== null && typeof e == "object" && "type" in e;
}
const F = (
  // Note: overloads like this are needed to support optional generics.
  /**
   * @type {(
   *   (<Kind extends UnistParent, Check extends Test>(parent: Kind, index: Child<Kind> | number, test: Check) => Matches<Child<Kind>, Check> | undefined) &
   *   (<Kind extends UnistParent>(parent: Kind, index: Child<Kind> | number, test?: null | undefined) => Child<Kind> | undefined)
   * )}
   */
  /**
   * @param {UnistParent} parent
   * @param {UnistNode | number} index
   * @param {Test} [test]
   * @returns {UnistNode | undefined}
   */
  function(e, t, r) {
    const o = H(r);
    if (!e || !e.type || !e.children)
      throw new Error("Expected parent node");
    if (typeof t == "number") {
      if (t < 0 || t === Number.POSITIVE_INFINITY)
        throw new Error("Expected positive finite number as index");
    } else if (t = e.children.indexOf(t), t < 0)
      throw new Error("Expected child node or index");
    for (; ++t < e.children.length; )
      if (o(e.children[t], t, e))
        return e.children[t];
  }
), g = (
  // Note: overloads in JSDoc can’t yet use different `@template`s.
  /**
   * @type {(
   *   (<Condition extends TestFunction>(test: Condition) => (element: unknown, index?: number | null | undefined, parent?: Parents | null | undefined, context?: unknown) => element is Element & Predicate<Condition, Element>) &
   *   (<Condition extends string>(test: Condition) => (element: unknown, index?: number | null | undefined, parent?: Parents | null | undefined, context?: unknown) => element is Element & {tagName: Condition}) &
   *   ((test?: null | undefined) => (element?: unknown, index?: number | null | undefined, parent?: Parents | null | undefined, context?: unknown) => element is Element) &
   *   ((test?: Test) => Check)
   * )}
   */
  /**
   * @param {Test | null | undefined} [test]
   * @returns {Check}
   */
  function(e) {
    if (e == null)
      return te;
    if (typeof e == "string")
      return ee(e);
    if (typeof e == "object")
      return Z(e);
    if (typeof e == "function")
      return E(e);
    throw new Error("Expected function, string, or array as `test`");
  }
);
function Z(e) {
  const t = [];
  let r = -1;
  for (; ++r < e.length; )
    t[r] = g(e[r]);
  return E(o);
  function o(...s) {
    let i = -1;
    for (; ++i < t.length; )
      if (t[i].apply(this, s)) return !0;
    return !1;
  }
}
function ee(e) {
  return E(t);
  function t(r) {
    return r.tagName === e;
  }
}
function E(e) {
  return t;
  function t(r, o, s) {
    return !!(ne(r) && e.call(
      this,
      r,
      typeof o == "number" ? o : void 0,
      s || void 0
    ));
  }
}
function te(e) {
  return !!(e && typeof e == "object" && "type" in e && e.type === "element" && "tagName" in e && typeof e.tagName == "string");
}
function ne(e) {
  return e !== null && typeof e == "object" && "type" in e && "tagName" in e;
}
const S = /\n/g, O = /[\t ]+/g, A = g("br"), B = g(he), re = g("p"), v = g("tr"), ie = g([
  // List from: <https://html.spec.whatwg.org/multipage/rendering.html#hidden-elements>
  "datalist",
  "head",
  "noembed",
  "noframes",
  "noscript",
  // Act as if we support scripting.
  "rp",
  "script",
  "style",
  "template",
  "title",
  // Hidden attribute.
  le,
  // From: <https://html.spec.whatwg.org/multipage/rendering.html#flow-content-3>
  ae
]), W = g([
  "address",
  // Flow content
  "article",
  // Sections and headings
  "aside",
  // Sections and headings
  "blockquote",
  // Flow content
  "body",
  // Page
  "caption",
  // `table-caption`
  "center",
  // Flow content (legacy)
  "dd",
  // Lists
  "dialog",
  // Flow content
  "dir",
  // Lists (legacy)
  "dl",
  // Lists
  "dt",
  // Lists
  "div",
  // Flow content
  "figure",
  // Flow content
  "figcaption",
  // Flow content
  "footer",
  // Flow content
  "form,",
  // Flow content
  "h1",
  // Sections and headings
  "h2",
  // Sections and headings
  "h3",
  // Sections and headings
  "h4",
  // Sections and headings
  "h5",
  // Sections and headings
  "h6",
  // Sections and headings
  "header",
  // Flow content
  "hgroup",
  // Sections and headings
  "hr",
  // Flow content
  "html",
  // Page
  "legend",
  // Flow content
  "li",
  // Lists (as `display: list-item`)
  "listing",
  // Flow content (legacy)
  "main",
  // Flow content
  "menu",
  // Lists
  "nav",
  // Sections and headings
  "ol",
  // Lists
  "p",
  // Flow content
  "plaintext",
  // Flow content (legacy)
  "pre",
  // Flow content
  "section",
  // Sections and headings
  "ul",
  // Lists
  "xmp"
  // Flow content (legacy)
]);
function N(e, t) {
  const r = t || {}, o = "children" in e ? e.children : [], s = W(e), i = K(e, {
    whitespace: r.whitespace || "normal",
    breakBefore: !1,
    breakAfter: !1
  }), n = [];
  (e.type === "text" || e.type === "comment") && n.push(
    ...R(e, {
      whitespace: i,
      breakBefore: !0,
      breakAfter: !0
    })
  );
  let c = -1;
  for (; ++c < o.length; )
    n.push(
      ..._(
        o[c],
        // @ts-expect-error: `tree` is a parent if we’re here.
        e,
        {
          whitespace: i,
          breakBefore: c ? void 0 : s,
          breakAfter: c < o.length - 1 ? A(o[c + 1]) : s
        }
      )
    );
  const l = [];
  let a;
  for (c = -1; ++c < n.length; ) {
    const p = n[c];
    typeof p == "number" ? a !== void 0 && p > a && (a = p) : p && (a !== void 0 && a > -1 && l.push(`
`.repeat(a) || " "), a = -1, l.push(p));
  }
  return l.join("");
}
function _(e, t, r) {
  return e.type === "element" ? oe(e, t, r) : e.type === "text" ? r.whitespace === "normal" ? R(e, r) : se(e) : [];
}
function oe(e, t, r) {
  const o = K(e, r), s = e.children || [];
  let i = -1, n = [];
  if (ie(e))
    return n;
  let c, l;
  for (A(e) || v(e) && // @ts-expect-error: something up with types of parents.
  F(t, e, v) ? l = `
` : re(e) ? (c = 2, l = 2) : W(e) && (c = 1, l = 1); ++i < s.length; )
    n = n.concat(
      _(s[i], e, {
        whitespace: o,
        breakBefore: i ? void 0 : c,
        breakAfter: i < s.length - 1 ? A(s[i + 1]) : l
      })
    );
  return B(e) && // @ts-expect-error: something up with types of parents.
  F(t, e, B) && n.push("	"), c && n.unshift(c), l && n.push(l), n;
}
function R(e, t) {
  const r = String(e.value), o = [], s = [];
  let i = 0;
  for (; i <= r.length; ) {
    S.lastIndex = i;
    const l = S.exec(r), a = l && "index" in l ? l.index : r.length;
    o.push(
      // Any sequence of collapsible spaces and tabs immediately preceding or
      // following a segment break is removed.
      ce(
        // […] ignoring bidi formatting characters (characters with the
        // Bidi_Control property [UAX9]: ALM, LTR, RTL, LRE-RLO, LRI-PDI) as if
        // they were not there.
        r.slice(i, a).replace(/[\u061C\u200E\u200F\u202A-\u202E\u2066-\u2069]/g, ""),
        i === 0 ? t.breakBefore : !0,
        a === r.length ? t.breakAfter : !0
      )
    ), i = a + 1;
  }
  let n = -1, c;
  for (; ++n < o.length; )
    o[n].charCodeAt(o[n].length - 1) === 8203 || n < o.length - 1 && o[n + 1].charCodeAt(0) === 8203 ? (s.push(o[n]), c = void 0) : o[n] ? (typeof c == "number" && s.push(c), s.push(o[n]), c = 0) : (n === 0 || n === o.length - 1) && s.push(0);
  return s;
}
function se(e) {
  return [String(e.value)];
}
function ce(e, t, r) {
  const o = [];
  let s = 0, i;
  for (; s < e.length; ) {
    O.lastIndex = s;
    const n = O.exec(e);
    i = n ? n.index : e.length, !s && !i && n && !t && o.push(""), s !== i && o.push(e.slice(s, i)), s = n ? i + n[0].length : i;
  }
  return s !== i && !r && o.push(""), o.join(" ");
}
function K(e, t) {
  if (e.type === "element") {
    const r = e.properties || {};
    switch (e.tagName) {
      case "listing":
      case "plaintext":
      case "xmp":
        return "pre";
      case "nobr":
        return "nowrap";
      case "pre":
        return r.wrap ? "pre-wrap" : "pre";
      case "td":
      case "th":
        return r.noWrap ? "nowrap" : t.whitespace;
      case "textarea":
        return "pre-wrap";
    }
  }
  return t.whitespace;
}
function le(e) {
  return !!(e.properties || {}).hidden;
}
function he(e) {
  return e.tagName === "td" || e.tagName === "th";
}
function ae(e) {
  return e.tagName === "dialog" && !(e.properties || {}).open;
}
const P = {
  "rehype-highlighter-inline-code": {
    name: "rehype-highlighter-inline-code",
    code: function(e) {
      e.properties.class = e.properties.class || "", this.pre.properties && this.pre.properties.class && e.properties && (e.properties.class = e.properties.class + this.pre.properties.class.toString()), e.properties["data-rh-highlighter-inline"] = !0;
    }
  },
  "rehype-highlighter-space-substitution": {
    name: "rehype-highlighter-space-substitution",
    code: function(e) {
      L(e, "text", function(t) {
        t.value = t.value.replace(/\s/g, "&nbsp;");
      });
    }
  }
}, y = U(V), ge = (e = {}) => (t) => new Promise((r) => {
  (async () => {
    var l, a, p;
    const o = [], s = {
      inlineCode: {
        spaceSubstitution: !1
      }
    }, i = {
      transformers: []
    }, n = Object.assign({}, s, e);
    let c = [];
    n && n.themes && c.push(...Object.values(n.themes)), n && n.inlineCode && n.inlineCode.theme && c.push(n.inlineCode.theme), n.loadThemes && c.push(...n.loadThemes), n && n.theme && c.push(n.theme), c = c.filter((u) => !(typeof u == "string" && !Object.keys(Y).includes(u))), await y({ themes: c }), L(t, { tagName: "code" }, (u, d) => {
      const h = d.at(-1);
      return (h == null ? void 0 : h.tagName) === "pre" && u.properties.className && (h == null ? void 0 : h.children.length) == 1 && u.properties.className.some((f) => f.startsWith("language-")) ? (o.push({ node: u, ancestors: d, type: "block" }), C) : (
        /** parseInlineCode function extracts the token(language) from the node.
         * It returns an object if it finds a token else it returns the original
         * string
         */
        typeof j(N(u)) != "string" && (h == null ? void 0 : h.tagName) !== "pre" ? (o.push({ node: u, ancestors: d, type: "inline" }), C) : D
      );
    });
    for (const { node: u, ancestors: d } of o.filter(({ type: h }) => h === "block")) {
      const h = d.at(-1), f = d.at(-2), m = f == null ? void 0 : f.children.findIndex((k) => k === h);
      if (m == null) return;
      n.theme == null ? i.themes = n.themes : i.theme = n.theme, i.lang = z(u), await y({ langs: [i.lang] });
      const w = (await y()).codeToHtml(
        N(u, { whitespace: "pre" }),
        i
      ), x = I(w);
      f == null || f.children.splice(m, 1, T(x));
    }
    for (const { node: u, ancestors: d } of o.filter(({ type: h }) => h === "inline")) {
      const h = ((l = n.inlineCode) == null ? void 0 : l.theme) || n.theme, f = d.at(-1), m = f == null ? void 0 : f.children.findIndex((q) => q === u);
      if (m === void 0) return;
      const { token: w, content: x } = j(N(u));
      (a = i.transformers) == null || a.push(P["rehype-highlighter-inline-code"]), h == null ? i.themes = n.themes : i.theme = h, i.lang = w, (p = n.inlineCode) != null && p.spaceSubstitution && i.transformers && i.transformers.push(P["rehype-highlighter-space-substitution"]);
      const k = (await y({ langs: [i.lang] })).codeToHtml(x, i), $ = I(k).childNodes[0].childNodes[0];
      f.children[m] = T($);
    }
  })().then(() => r());
});
export {
  ge as default
};
